/*
 * code_xxx.c
 */
void header(char *name);
void nl();
int galign(int t);
int intsize();
int byteoff();
void olprfix();
void col();
void comment();
void prefix();
void trailer();
void prologue();
void gtext();
void gdata();
void ppubext(sym_t *scptr);
void fpubext(sym_t *scptr);
void onum(int num);
void getmem(sym_t *sym);
void getloc(sym_t *sym);
void putmem(sym_t *sym);
void putstk(char typeobj);
void indirect(char typeobj);
void swap();
void immed();
void gpush();
void gpop();
void swapstk();
void gcall(char *sname);
void stdcall(char *sname);
void gret();
void callstk();
void jump(int label);
void testjump(int label, int ft);
void defbyte();
void defstorage();
void defword();
int modstk(int newstkp);
void gaslint();
void gasrint();
void gjcase();
void gadd(lval_t *lval, lval_t *lval2);
void gsub();
void gmult();
void gdiv();
void gmod();
void gor();
void gxor();
void gand();
void gasr();
void gasl();
void gneg();
void glneg();
void gcom();
void gbool();
void ginc(lval_t *lval);
void gdec(lval_t *lval);
void geq();
void gne();
void glt();
void gle();
void ggt();
void gge();
void gult();
void gule();
void gugt();
void guge();
void gnargs(int d);

/*
 * error.c
 */
void error(char *ptr);
void doerror(char *ptr);

/*
 * expr.c
 */
void expression(int comma);
int heir1(lval_t *lval);
int heir1a(lval_t *lval);
int heir1b(lval_t *lval);
int heir1c(lval_t *lval);
int heir2(lval_t *lval);
int heir3(lval_t *lval);
int heir4(lval_t *lval);
int heir5(lval_t *lval);
int heir6(lval_t *lval);
int heir7(lval_t *lval);
int heir8(lval_t *lval);
int heir9(lval_t *lval);
int heir10(lval_t *lval);
int heir11(lval_t *lval);

/*
 * function.c
 */
void newfunc();
void newansifunc(char *n);
void getarg(int t);
void getansiarg(int t);

/*
 * gen.c
 */
int getlabel();
void printlabel(int label);
void glabel(char *lab);
void gnlabel(int nlab);
int outbyte(char c);
void outstr(char *ptr);
void tab();
void ol (char *ptr);
void ot(char *ptr);
void outdec(int number);
void store(lval_t *lval);
void rvalue (lval_t *lval);
void test(int label, int ft);

/*
 * io.c
 */
int openin(char *p);
int openout();
void changefname(char *s);
void fixname(char *s);
int checkname(char *s);
void kill();
void inpline();
int inpbyte();
int inpchar();
int gch();
int nch();
int ch();
void doasm();

/*
 * lex.c
 */
void ns();
void junk();
int endst();
void needbrack(char *str);
int alpha(char c);
int an(char c);
int sstreq(char *str1);
int streq(char *str1, char *str2);
int astreq(char *str1, char *str2, int len);
int match(char *lit);
int amatch(char *lit, int len);
void blanks();

/*
 * main.c
 */
void FEvers();
void usage();
void parse();
int dodcls(int stclass);
void dumplits();
void dumpglbs();
void errorsummary();
int type(char *s);

/*
 * primary.c
 */
int primary(lval_t *lval);
int dbltest(lval_t *val1, lval_t *val2);
void result(lval_t *lval, lval_t *lval2);
int constant(int *val);
int number(int *val);
int pstr(int *val);
int qstr(int *val);
int spechar();
void callfunction(char *ptr);
void needlval ();

/*
 * stmt.c
 */
int statement(int func);
int stdecl();
int doldcls(int stclass);
void stst();
void compnd(int func);
void doif();
void dowhile();
void dodo();
void dofor();
void doswitch();
void docase();
void dodefault();
void doreturn();
void dobreak();
void docont();
void dumpsw(ws_t *ws);

/*
 * sym.c
 */
int declglb(int typ, int stor);
void declloc(int typ, int stclass);
int needsub();
sym_t *findglb(char *sname);
sym_t *findloc(char *sname);
sym_t *addglb(char *sname, char id, char typ, int value, int stor);
sym_t *addloc(char *sname, char id, char typ, int value, int stclass);
int symname(char *sname);
void illname();
void multidef(char *sname);
int glint(sym_t *syment);

/*
 * while.c
 */
void addwhile(ws_t *ptr);
void delwhile();
ws_t *readwhile();
ws_t *findwhile();
ws_t *readswitch();
void addcase(int val);
