/*	File defs.h: 2.1 (83/03/21,02:07:20) */


#define	FOREVER	for(;;)
#ifndef FALSE
#define	FALSE	0
#endif
#ifndef TRUE
#define	TRUE	1
#endif
#define	NO	0
#define	YES	1
#define	ERROR	1
#define	OK	0

/* miscellaneous */

#define	EOS	'\0'
#define	EOL	'\n'
#define	BKSP	'\b'
#define	CR	'\r'
#define	FFEED	'\f'
#define TAB	'\t'

/* symbol table parameters */

#define	SYMTBSZ	200
#define	NUMGLBS	150
#define	STARTGLB	symtab
#define	ENDGLB	(STARTGLB+NUMGLBS)
#define	STARTLOC	(ENDGLB+1)
#define	ENDLOC	(symtab+SYMTBSZ-1)

/* system-wide name size (for symbols) */

#define	NAMEMAX	16
#define	NAMESIZE	(NAMEMAX+1)

/* possible entries for "ident" */

#define	VARIABLE	1
#define	ARRAY	2
#define	POINTER	3
#define	FUNCTION	4

/* possible entries for "type" */

#define	CCHAR	1
#define	CINT	2

/* possible entries for storage */

#define	PUBLIC	1
#define	AUTO	2
#define	EXTERN	3

#define	STATIC	4
#define	LSTATIC	5
#define	DEFAUTO	6
/* "do"/"for"/"while"/"switch" statement stack */

#define	WSTABSZ	100
#define	WSMAX	ws+WSTABSZ

/* possible entries for "wstyp" */

#define	WSWHILE	0
#define	WSFOR	1
#define	WSDO	2
#define	WSSWITCH	3

/* "switch" label stack */

#define	SWSTSZ	100

/* literal pool */

#define	LITABSZ	2000
#define	LITMAX	LITABSZ-1

/* input line */

#define	LINESIZE	150
#define	LINEMAX	(LINESIZE-1)
#define	MPMAX	LINEMAX

/* statement types (tokens) */

#define	STIF	1
#define	STWHILE	2
#define	STRETURN	3
#define	STBREAK	4
#define	STCONT	5
#define	STASM	6
#define	STEXP	7
#define	STDO	8
#define	STFOR	9
#define	STSWITCH	10

typedef struct _sym_t {
  char name[NAMESIZE];
  unsigned char ident;
  unsigned char type;
  unsigned char storage;
  int offset;
} sym_t;

typedef struct _lval_t {
  sym_t *addr;
  int what;
  int type;
} lval_t;

typedef struct _ws_t {
  sym_t *sym;
  int sp;
  int type;
  int test_casep;
  int incr_def;
  int body_tab;
  int exit;
} ws_t;
