#include <stdio.h>
#include "defs.h"
#include "data.h"
#include "decls.h"

/*
 *	lval.addr - symbol table address, else 0 for constant
 *	lval.what - type indirect object to fetch, else 0 for static object
 *	lval.type - type pointer or array, else 0
 */

void expression(int comma)
{
  lval_t lval;
  lval.addr = NULL;

  do {
    if (heir1 (&lval))
      rvalue (&lval);
    if (!comma)
      return;
  } while (match (","));
}

int heir1(lval_t *lval)
{
  int k;
  lval_t lval2;
  char fc;

  k = heir1a (lval);
  if (match ("=")) {
    if (k == 0) {
      needlval ();
      return (0);
    }
    if (lval->what)
      gpush ();
    if (heir1 (&lval2))
      rvalue (&lval2);
    store (lval);
    return (0);
  } else
    {	
      fc = ch();
      if  (match ("-=") ||
	   match ("+=") ||
	   match ("*=") ||
	   match ("/=") ||
	   match ("%=") ||
	   match (">>=") ||
	   match ("<<=") ||
	   match ("&=") ||
	   match ("^=") ||
	   match ("|=")) {
	if (k == 0) {
	  needlval ();
	  return (0);
	}
	if (lval->what)
	  gpush ();
	rvalue (lval);
	gpush ();
	if (heir1 (&lval2))
	  rvalue (&lval2);
	switch (fc) {
	case '-':	{
	  if (dbltest(lval,&lval2))
	    gaslint();
	  gsub();
	  result (lval,&lval2);
	  break;
	}
	case '+':	{
	  if (dbltest(lval,&lval2))
	    gaslint();
	  gadd(lval,&lval2);
	  result(lval,&lval2);
	  break;
	}
	case '*':	gmult (); break;
	case '/':	gdiv (); break;
	case '%':	gmod (); break;
	case '>':	gasr (); break;
	case '<':	gasl (); break;
	case '&':	gand (); break;
	case '^':	gxor (); break;
	case '|':	gor (); break;
	}
	store (lval);
	return (0);
      } else
	return (k);
    }
}

int heir1a(lval_t *lval)
{
  int k, lab1, lab2;
  lval_t lval2;

  k = heir1b (lval);
  blanks ();
  if (ch () != '?')
    return (k);
  if (k)
    rvalue (lval);
  FOREVER
    if (match ("?")) {
      testjump (lab1 = getlabel (), FALSE);
      if (heir1b (&lval2))
	rvalue (&lval2);
      jump (lab2 = getlabel ());
      printlabel (lab1);
      col ();
      nl ();
      blanks ();
      if (!match (":")) {
	error ("missing colon");
	return (0);
      }
      if (heir1b (&lval2))
	rvalue (&lval2);
      printlabel (lab2);
      col ();
      nl ();
    } else
      return (0);
}

int heir1b(lval_t *lval)
{
  int k, lab;
  lval_t lval2;

  k = heir1c (lval);
  blanks ();
  if (!sstreq ("||"))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER
    if (match ("||")) {
      testjump (lab = getlabel (), TRUE);
      if (heir1c (&lval2))
	rvalue (&lval2);
      printlabel (lab);
      col ();
      nl ();
      gbool();
    } else
      return (0);
}

int heir1c(lval_t *lval)
{
  int k, lab;
  lval_t lval2;

  k = heir2 (lval);
  blanks ();
  if (!sstreq ("&&"))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER
    if (match ("&&")) {
      testjump (lab = getlabel (), FALSE);
      if (heir2 (&lval2))
	rvalue (&lval2);
      printlabel (lab);
      col ();
      nl ();
      gbool();
    } else
      return (0);
}

int heir2(lval_t *lval)
{
  int k;
  lval_t lval2;

  k = heir3 (lval);
  blanks ();
  if ((ch() != '|') || (nch() == '|') || (nch() == '='))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER {
    if ((ch() == '|') && (nch() != '|') && (nch() != '=')) {
      inpbyte ();
      gpush ();
      if (heir3 (&lval2))
	rvalue (&lval2);
      gor ();
      blanks();
    } else
      return (0);
  }
}

int heir3(lval_t *lval)
{
  int k;
  lval_t lval2;

  k = heir4 (lval);
  blanks ();
  if ((ch () != '^') || (nch() == '='))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER {
    if ((ch() == '^') && (nch() != '=')){
      inpbyte ();
      gpush ();
      if (heir4 (&lval2))
	rvalue (&lval2);
      gxor ();
      blanks();
    } else
      return (0);
  }
}

int heir4(lval_t *lval)
{
  int k;
  lval_t lval2;

  k = heir5 (lval);
  blanks ();
  if ((ch() != '&') || (nch() == '|') || (nch() == '='))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER {
    if ((ch() == '&') && (nch() != '&') && (nch() != '=')) {
      inpbyte ();
      gpush ();
      if (heir5 (&lval2))
	rvalue (&lval2);
      gand ();
      blanks();
    } else
      return (0);
  }
}

int heir5(lval_t *lval)
{
  int k;
  lval_t lval2;

  k = heir6 (lval);
  blanks ();
  if (!sstreq ("==") &
      !sstreq ("!="))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER {
    if (match ("==")) {
      gpush ();
      if (heir6 (&lval2))
	rvalue (&lval2);
      geq ();
    } else if (match ("!=")) {
      gpush ();
      if (heir6 (&lval2))
	rvalue (&lval2);
      gne ();
    } else
      return (0);
  }
}

int heir6(lval_t *lval)
{
  int k;
  lval_t lval2;

  k = heir7 (lval);
  blanks ();
  if (!sstreq ("<") &&
      !sstreq ("<=") &&
      !sstreq (">=") &&
      !sstreq (">"))
    return (k);
  if (sstreq ("<<") || sstreq (">>"))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER {
    if (match ("<=")) {
      gpush ();
      if (heir7 (&lval2))
	rvalue (&lval2);
      if (lval->type || lval2.type) {
	gule ();
	continue;
      }
      gle ();
    } else if (match (">=")) {
      gpush ();
      if (heir7 (&lval2))
	rvalue (&lval2);
      if (lval->type || lval2.type) {
	guge ();
	continue;
      }
      gge ();
    } else if ((sstreq ("<")) &&
	       !sstreq ("<<")) {
      inpbyte ();
      gpush ();
      if (heir7 (&lval2))
	rvalue (&lval2);
      if (lval->type || lval2.type) {
	gult ();
	continue;
      }
      glt ();
    } else if ((sstreq (">")) &&
	       !sstreq (">>")) {
      inpbyte ();
      gpush ();
      if (heir7 (&lval2))
	rvalue (&lval2);
      if (lval->type || lval2.type) {
	gugt ();
	continue;
      }
      ggt ();
    } else
      return (0);
    blanks ();
  }
}

int heir7(lval_t *lval)
{
  int k;
  lval_t lval2;

  k = heir8 (lval);
  blanks ();
  if ((!sstreq (">>") &&
      !sstreq ("<<")) || sstreq(">>=") || sstreq("<<="))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER {
    if (sstreq(">>") && ! sstreq(">>=")) {
      inpbyte(); inpbyte();
      gpush ();
      if (heir8 (&lval2))
	rvalue (&lval2);
      gasr ();
    } else if (sstreq("<<") && ! sstreq("<<=")) {
      inpbyte(); inpbyte();
      gpush ();
      if (heir8 (&lval2))
	rvalue (&lval2);
      gasl ();
    } else
      return (0);
    blanks();
  }
}

int heir8(lval_t *lval)
{
  int k;
  lval_t lval2;

  k = heir9 (lval);
  blanks ();
  if (((ch () != '+') && (ch () != '-')) || (nch() == '='))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER {
    if (match ("+")) {
      gpush ();
      if (heir9 (&lval2))
	rvalue (&lval2);
      /* if left is pointer and right is int, scale right */
      if (dbltest (lval, &lval2))
	gaslint ();
      /* will scale left if right int pointer and left int */
      gadd (lval,&lval2);
      result (lval, &lval2);
    } else if (match ("-")) {
      gpush ();
      if (heir9 (&lval2))
	rvalue (&lval2);
      /* if dbl, can only be: pointer - int, or
	 pointer - pointer, thus,
	 in first case, int is scaled up,
	 in second, result is scaled down. */
      if (dbltest (lval, &lval2))
	gaslint ();
      gsub ();
      /* if both pointers, scale result */
      if ((lval->type == CINT) && (lval2.type == CINT)) {
	gasrint(); /* divide by intsize */
      }
      result (lval, &lval2);
    } else
      return (0);
  }
}

int heir9(lval_t *lval)
{
  int k;
  lval_t lval2;

  k = heir10 (lval);
  blanks ();
  if (((ch () != '*') && (ch () != '/') &&
       (ch () != '%')) || (nch() == '='))
    return (k);
  if (k)
    rvalue (lval);
  FOREVER {
    if (match ("*")) {
      gpush ();
      if (heir10 (&lval2))
	rvalue (&lval2);
      gmult ();
    } else if (match ("/")) {
      gpush ();
      if (heir10 (&lval2))
	rvalue (&lval2);
      gdiv ();
    } else if (match ("%")) {
      gpush ();
      if (heir10 (&lval2))
	rvalue (&lval2);
      gmod ();
    } else
      return (0);
  }
}

int heir10(lval_t *lval)
{
  int k;
  sym_t *ptr;

  if (match ("++")) {
    if ((k = heir10 (lval)) == 0) {
      needlval ();
      return (0);
    }
    if (lval->what)
      gpush ();
    rvalue (lval);
    ginc (lval);
    store (lval);
    return (0);
  } else if (match ("--")) {
    if ((k = heir10 (lval)) == 0) {
      needlval ();
      return (0);
    }
    if (lval->what)
      gpush ();
    rvalue (lval);
    gdec (lval);
    store (lval);
    return (0);
  } else if (match ("-")) {
    k = heir10 (lval);
    if (k)
      rvalue (lval);
    gneg ();
    return (0);
  } else if (match ("~")) {
    k = heir10 (lval);
    if (k)
      rvalue (lval);
    gcom ();
    return (0);
  } else if (match ("!")) {
    k = heir10 (lval);
    if (k)
      rvalue (lval);
    glneg ();
    return (0);
  } else if (ch()=='*' && nch() != '=') {
    inpbyte();
    k = heir10 (lval);
    if (k)
      rvalue (lval);
    if ((ptr = lval->addr))
      lval->what = ptr->type;
    else
      lval->what = CINT;
    lval->type = 0;  /* flag as not pointer or array */
    return (1);
  } else if (ch()=='&' && nch()!='&' && nch()!='=') {
    inpbyte();
    k = heir10 (lval);
    if (k == 0) {
      error ("illegal address");
      return (0);
    }
    ptr = lval->addr;
    lval->type = ptr->type;
    if (lval->what)
      return (0);
    /* global and non-array */
    immed ();
    prefix ();
    ptr = lval->addr;
    outstr (ptr->name);
    nl ();
    lval->what = ptr->type;
    return (0);
  } else {
    k = heir11 (lval);
    if (match ("++")) {
      if (k == 0) {
	needlval ();
	return (0);
      }
      if (lval->what)
	gpush ();
      rvalue (lval);
      ginc (lval);
      store (lval);
      gdec (lval);
      return (0);
    } else if (match ("--")) {
      if (k == 0) {
	needlval ();
	return (0);
      }
      if (lval->what)
	gpush ();
      rvalue (lval);
      gdec (lval);
      store (lval);
      ginc (lval);
      return (0);
    } else
      return (k);
  }
}

int heir11(lval_t *lval)
{
  int k;
  sym_t *ptr;

  k = primary (lval);
  ptr = lval->addr;
  blanks ();
  if ((ch () == '[') || (ch () == '('))
    FOREVER {
      if (match ("[")) {
	if (ptr == 0) {
	  error ("can't subscript");
	  junk ();
	  needbrack ("]");
	  return (0);
	} else if (ptr->ident == POINTER)
	  rvalue (lval);
	else if (ptr->ident != ARRAY) {
	  error ("can't subscript");
	  k = 0;
	}
	gpush ();
	expression (YES);
	needbrack ("]");
	if (ptr->type == CINT)
	  gaslint ();
	gadd (NULL,NULL);
	lval->addr = 0;
	lval->what = ptr->type;
	k = 1;
      } else if (match ("(")) {
	if (ptr == 0)
	  callfunction (0);
	else if (ptr->ident != FUNCTION) {
	  rvalue (lval);
	  callfunction (0);
	} else
	  callfunction (ptr->name);
	k = 0;
	lval->addr = 0;
      } else
	return (k);
    }
  if (ptr == 0)
    return (k);
  if (ptr->ident == FUNCTION) {
    immed ();
    prefix ();
    outstr (ptr->name);
    nl ();
    return (0);
  }
  return (k);
}
